routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Dashboard\Student\AllCourses\MainController as AllCoursesMain;
use App\Http\Controllers\Dashboard\Student\MyCourses\MainController as MyCoursesMain;
use App\Http\Controllers\Dashboard\Student\MyCourses\CourseController as StdCourseController;
use App\Http\Controllers\Dashboard\Student\MyCourses\MaterialController as StdMaterialController;
use App\Http\Controllers\Dashboard\Student\MyCourses\AssignmentController as StdAssignmentController;
use App\Http\Controllers\Dashboard\Creator\Dashboard\MainController as CreatorDashboardMain;
use App\Http\Controllers\Dashboard\Creator\ManageCourses\MainController as ManageCoursesMain;
use App\Http\Controllers\Dashboard\Creator\ManageCourses\CourseController as CrtCourseController;
use App\Http\Controllers\Dashboard\Creator\ManageCourses\MaterialController as CrtMaterialController;
use App\Http\Controllers\Dashboard\Creator\ManageCourses\AssignmentController;
use App\Http\Controllers\Dashboard\Creator\ManageCourses\SubmissionController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
  return view('layouts.master-landing');
});

Route::get('/me', function () {
  return view('layouts.master-dashboard');
});

Route::group([
  'as'  => 'student.',
  'prefix' => 'student'
], function () {
  Route::get('/dashboard', function () {
    return view('layouts.master-dashboard');
  })->name('dashboard.index');

  Route::get('/my-courses', [MyCoursesMain::class, 'index'])->name('my-courses.index');
  Route::get('/my-courses/{course}', [StdCourseController::class, 'show'])->name('my-courses.course.show');
  Route::get('/my-courses/{course}/material/{session}', [StdMaterialController::class, 'show'])->name('my-courses.course.material.show');
  Route::get('/my-courses/{course}/assignment/{assignment}', [StdAssignmentController::class, 'show'])->name('my-courses.course.assignment.show');

  Route::get('/all-courses', [AllCoursesMain::class, 'index'])->name('all-courses.index');
  Route::get('/all-courses/{course}', [AllCoursesMain::class, 'show'])->name('all-courses.show');
});

Route::group([
  'as'  => 'creator.',
  'prefix' => 'creator'
], function () {
  Route::get('/dashboard', [CreatorDashboardMain::class, 'index'])->name('dashboard.index');

  Route::get('/manage-courses', [ManageCoursesMain::class, 'index'])->name('manage-courses.index');

  Route::post('/manage-courses/course', [CrtCourseController::class, 'store'])->name('manage-courses.course.store');
  Route::get('/manage-courses/course/{course}', [CrtCourseController::class, 'show'])->name('manage-courses.course.show');
  Route::put('/manage-courses/course/{course}', [CrtCourseController::class, 'update'])->name('manage-courses.course.update');
  Route::delete('manage-courses/course/{course}', [CrtCourseController::class, 'destroy'])->name('manage-courses.course.destroy');
  Route::get('/manage-courses/course/{course}/create', [CrtCourseController::class, 'create'])->name('manage-courses.course.create');

  Route::get('/manage-courses/course/{course}/{assignment}', [AssignmentController::class, 'show'])->name('manage-courses.course.assignment.show');
  Route::get('/manage-courses/course/{course}/{assignment}/{assignmentSubmission}', [SubmissionController::class, 'show'])->name('manage-courses.course.assignment.submission.show');

  Route::get('/manage-courses/material/{material}', [CrtMaterialController::class, 'show'])->name('manage-courses.material.show');

  Route::get('/revenue', function () {
    return view('layouts.master-dashboard');
  })->name('revenue.index');
});

Route::group([
  'as'  => 'admin.',
  'prefix' => 'admin'
], function () {
  Route::get('/user-control', function () {
    return view('layouts.master-dashboard');
  })->name('user-control.index');
  Route::get('/transaction-history', function () {
    return view('layouts.master-dashboard');
  })->name('transaction-history.index');
});

Route::middleware([
  'auth:sanctum',
  config('jetstream.auth_session'),
  'verified'
])->group(function () {
  Route::get('/dashboard', function () {
    return view('dashboard');
  })->name('dashboard');
});

Route::group(['prefix' => 'laravel-filemanager', 'middleware' => ['web']], function () {
  \UniSharp\LaravelFilemanager\Lfm::routes();
});

app/Models/Assignment.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Assignment extends Model
{
    use HasFactory;
	
	protected $guarded = [];
	
	public function material()
	{
		return $this->belongsTo(Material::class);
	}
	
	public function courseAssignments()
	{
		return $this->hasMany(CourseAssignment::class);
	}
	
	public function assignmentQuestions()
	{
		return $this->hasMany(AssignmentQuestion::class);
	}
}

app/Http/Controllers/Dashboard/Creator/ManageCourses/AssignmentController.php
<?php

namespace App\Http\Controllers\Dashboard\Creator\ManageCourses;

use Carbon\Carbon;
use App\Models\Course;
use App\Models\Assignment;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class AssignmentController extends Controller
{
  public function show(Course $course, Assignment $assignment)
  {
    $courseAssignment = $assignment->courseAssignments()->where('course_id', $course->id)->first();
    $assignmentSubmissions = $courseAssignment->assignmentSubmissions()->orderBy('status', 'desc')->get();
    $scoredSubmission = $assignmentSubmissions->where('score', !null)->count();
    $submissionDurations = array();
    $submissionStatus = array();

    foreach ($assignmentSubmissions as $index => $assignmentSubmission) {
      $from = Carbon::parse(date('H:i:s.u', strtotime(explode(' ', Carbon::now())[1])));
      $to = Carbon::parse(date('H:i:s', strtotime($assignmentSubmission->duration)));

      if ($assignmentSubmission->status || $from > $to) {
        $submissionDurations[] = date('H:i:s', strtotime("00:00:00"));
        $submissionStatus[] = "Submitted";
      } else {
        $from = Carbon::parse(date('H:i:s.u', strtotime(explode(' ', Carbon::now())[1])));
        $to = Carbon::parse(date('H:i:s', strtotime($assignmentSubmission->duration)));
        $hour = (int) ($from->diffInHours($to) % 24);
        $minute = (int) ($from->diffInMinutes($to) % 60);
        $second = (int) ($from->diffInSeconds($to) % 60);
        $submissionDurations[] = date('H:i:s', strtotime($hour . ":" . $minute . ":" . $second));
        $submissionStatus[] = "On Work";
      }
    }

    return view('pages.dashboard.creator.manage-courses.course.assignment.show', compact('course', 'assignment', 'courseAssignment', 'assignmentSubmissions', 'scoredSubmission', 'submissionDurations', 'submissionStatus'));
  }
}

app/Http/Controllers/Dashboard/Creator/ManageCourses/SubmissionController.php
<?php

namespace App\Http\Controllers\Dashboard\Creator\ManageCourses;

use App\Http\Controllers\Controller;
use App\Models\Assignment;
use App\Models\AssignmentSubmission;
use App\Models\Course;
use Illuminate\Http\Request;

class SubmissionController extends Controller
{
  public function show(Course $course, Assignment $assignment, AssignmentSubmission $assignmentSubmission)
  {
    return view('pages.dashboard.creator.manage-courses.course.assignment.submission.show', compact('course', 'assignment', 'assignmentSubmission'));
  }
}

app/Http/Controllers/Dashboard/Student/MyCourses/AssignmentController.php
<?php

namespace App\Http\Controllers\Dashboard\Student\MyCourses;

use App\Http\Controllers\Controller;
use App\Models\Assignment;
use App\Models\AssignmentSubmission;
use App\Models\Course;
use App\Models\CourseAssignment;
use App\Models\SubmissionAnswer;
use Carbon\Carbon;
use Illuminate\Http\Request;

class AssignmentController extends Controller
{
  public function show(Course $course, Assignment $assignment)
  {
    $courseAssignment = $course->courseAssignments()->where('assignment_id', $assignment->id)->first();
    $assignmentSubmission = $courseAssignment->assignmentSubmissions()->where('user_id', auth()->id())->first();

    if (empty($assignmentSubmission)) {
      $assignmentSubmission = AssignmentSubmission::create([
        'user_id' => auth()->id(),
        'course_assignment_id' => $courseAssignment->id,
        'duration' => Carbon::now()->addHours((int) ($courseAssignment->duration / 60))->addMinutes($courseAssignment->duration % 60)
      ]);

      foreach ($assignment->assignmentQuestions as $index => $assignmentQuestion) {
        $assignmentSubmission->submissionAnswers()->create([
          'assignment_question_id' => $assignmentQuestion->id,
          'answer' => ''
        ]);
      }
    }

    // if (Carbon::now() > $assignmentSubmission->duration || ) {
    //   dd(Carbon::now()->diffInMilliseconds($assignmentSubmission->duration));
    // }

    return view('pages.dashboard.student.my-courses.course.assignment.show', compact('course', 'assignment', 'courseAssignment', 'assignmentSubmission'));
  }
}

resources/views/pages/dashboard/creator/manage-courses/course/assignment/submission/show.blade.php
@extends('layouts.master-dashboard')

@section('title', 'Submission Details')

@section('content')
	{{-- Breadcrumb Start --}}
	@livewire('dashboard.components.breadcrumb', ['routes' => [
			[
				'link' => route('creator.manage-courses.index'),
				'name' => 'Manage Courses'
			],
			[
				'link' => route('creator.manage-courses.course.show', ['course' => $course->id]),
				'name' => 'Course Details'
			],
			[
				'link' => route('creator.manage-courses.course.assignment.show', ['course' => $course->id, 'assignment' => $assignment->id]),
				'name' => 'Assignment Submissions'
			],
			[
				'link' => route('creator.manage-courses.course.assignment.submission.show', ['course' => $course->id, 'assignment' => $assignment->id, 'assignmentSubmission' => $assignmentSubmission->id]),
				'name' => 'Submission Details'
			]
		]
	])
	{{-- Breadcrumb End --}}
	
	<div class="lg:px-32">
		<div class="container">
			<div class="block bg-white my-2 px-8 py-4 rounded-md shadow-lg">
				{{-- Header Page Start --}}
				<div class="block">
					<h3 class="font-semibold text-xl text-dark text-center p-4 max-w-xl mx-auto lg:text-2xl">Submission Details</h3>
					
					<div class="block space-y-4 mt-8 sm:space-y-6">
						<div class="flex flex-nowrap items-center space-x-2 lg:space-x-4">
							<div class="rounded-full overflow-hidden shrink-0">
								<img src="{{ url('https://randomuser.me/api/portraits/men/33.jpg') }}" alt="Student Profile" class="w-10 h-10 rounded-full overflow-hidden object-cover">
							</div>
							
							<div class="block">
								<h4 class="font-medium text-dark">{{ $assignmentSubmission->user->name }}</h4>
								<h5 class="text-secondary text-sm">{{ $assignmentSubmission->user->email }}</h5>
							</div>
						</div>
						
						<button type="button" class="flex flex-nowrap items-center justify-center float-right w-40 my-2 p-1 space-x-2 bg-slate-200 rounded-md transition duration-300 hover:ring hover:ring-slate-200/70 hover:shadow-md">
							<span class="material-symbols-outlined text-secondary">
								task
							</span>
							
							<span class="font-medium text-sm text-secondary">Auto-score</span>
						</button>
						
						<div class="flex flex-nowrap space-x-2">
							<h4 class="font-medium text-sm text-dark">Total Score</h4>
							<span class="flex flex-nowrap space-x-1">
								<h5 class="text-sm text-secondary">:</h5>
								<h5 class="text-sm text-secondary">{{ $assignmentSubmission->score }}</h5>
							</span>
						</div>
					</div>
					
					<div class="flex items-end justify-between mt-8">
						<button type="button" class="flex flex-nowrap items-center justify-center my-2 p-1 bg-primary rounded-full transition duration-300 hover:ring hover:ring-primary-200/70 hover:shadow-md">
							<span class="material-symbols-outlined text-white">
								navigate_before
							</span>
							
							<span class="text-white mr-2">Prev</span>
						</button>
						
						<button type="button" class="flex flex-nowrap items-center justify-center my-2 p-1 bg-primary rounded-full transition duration-300 hover:ring hover:ring-primary-200/70 hover:shadow-md">
							<span class="text-white ml-2">Next</span>
							
							<span class="material-symbols-outlined text-white">
								navigate_next
							</span>
						</button>
					</div>	
				</div>
				{{-- Header Page End --}}
				
				{{-- Main Page Start --}}
				<div class="mx-auto my-8 max-w-lg xl:max-w-xl 2xl:max-w-2xl">
					<ol class="list-decimal space-y-36">
						<li class="space-y-8">
							<h4 class="text-dark text-justify">Lorem ipsum dolor, sit amet consectetur adipisicing elit. Cum quae repudiandae ipsam, totam debitis impedit nisi ut maxime officia ullam provident! Laborum nobis non reprehenderit excepturi, ducimus quod nesciunt nisi fugiat ut.</h4>
							
							<div class="block my-4 space-y-4">
								<span class="p-4 text-dark text-center float-right">
									<input type="text" x-on:click.stop class="w-10 border-0 border-b-2 border-secondary text-center p-1 focus:ring-0 focus:border-primary">
									<h5 class="inline"> / 25</h5>
								</span>
								
								<div class="p-4 w-full max-h-64 overflow-y-auto scrollbar text-secondary shadow-lg rounded-lg border border-slate-100">
									Lorem ipsum dolor sit amet consectetur adipisicing elit. Autem esse natus, sunt fuga enim facere impedit vero odio molestiae accusantium voluptas alias excepturi earum deleniti, quos, nemo quae et consequuntur quo assumenda? Debitis ut vitae eaque tempora. Explicabo ut commodi temporibus fugiat similique quasi dicta. Harum dolor iure reprehenderit. Quos illum, facilis qui fuga eos sed similique et atque eaque officiis tempore nobis praesentium dolore quae exercitationem, a fugit. Fugit tenetur aspernatur exercitationem aut? Optio tempora soluta ipsum neque natus, sed sunt officia obcaecati. Ipsa eum voluptates ducimus ratione enim voluptate assumenda laudantium nulla magni, cum rem maiores necessitatibus deleniti.
								</div>
							</div>
						</li>
						
						<li class="space-y-8">
							<h4 class="text-dark text-justify">Lorem ipsum dolor, sit amet consectetur adipisicing elit. Cum quae repudiandae ipsam, totam debitis impedit nisi ut maxime officia ullam provident! Laborum nobis non reprehenderit excepturi, ducimus quod nesciunt nisi fugiat ut.</h4>
							
							<div class="block my-4 space-y-4">
								<span class="p-4 text-dark text-center float-right">
									<input type="text" x-on:click.stop class="w-10 border-0 border-b-2 border-secondary text-center p-1 focus:ring-0 focus:border-primary">
									<h5 class="inline"> / 25</h5>
								</span>
								
								<div class="p-4 w-full max-h-64 overflow-y-auto scrollbar text-secondary shadow-lg rounded-lg border border-slate-100">
									Lorem ipsum dolor sit amet consectetur adipisicing elit. Autem esse natus, sunt fuga enim facere impedit vero odio molestiae accusantium voluptas alias excepturi earum deleniti, quos, nemo quae et consequuntur quo assumenda? Debitis ut vitae eaque tempora. Explicabo ut commodi temporibus fugiat similique quasi dicta. Harum dolor iure reprehenderit. Quos illum, facilis qui fuga eos sed similique et atque eaque officiis tempore nobis praesentium dolore quae exercitationem, a fugit. Fugit tenetur aspernatur exercitationem aut? Optio tempora soluta ipsum neque natus, sed sunt officia obcaecati. Ipsa eum voluptates ducimus ratione enim voluptate assumenda laudantium nulla magni, cum rem maiores necessitatibus deleniti.
								</div>
							</div>
						</li>
						
						<li class="space-y-8">
							<h4 class="text-dark text-justify">Lorem ipsum dolor, sit amet consectetur adipisicing elit. Cum quae repudiandae ipsam, totam debitis impedit nisi ut maxime officia ullam provident! Laborum nobis non reprehenderit excepturi, ducimus quod nesciunt nisi fugiat ut.</h4>
							
							<div class="block my-4 space-y-4">
								<span class="p-4 text-dark text-center float-right">
									<input type="text" x-on:click.stop class="w-10 border-0 border-b-2 border-secondary text-center p-1 focus:ring-0 focus:border-primary">
									<h5 class="inline"> / 25</h5>
								</span>
								
								<div class="p-4 w-full max-h-64 overflow-y-auto scrollbar text-secondary shadow-lg rounded-lg border border-slate-100">
									Lorem ipsum dolor sit amet consectetur adipisicing elit. Autem esse natus, sunt fuga enim facere impedit vero odio molestiae accusantium voluptas alias excepturi earum deleniti, quos, nemo quae et consequuntur quo assumenda? Debitis ut vitae eaque tempora. Explicabo ut commodi temporibus fugiat similique quasi dicta. Harum dolor iure reprehenderit. Quos illum, facilis qui fuga eos sed similique et atque eaque officiis tempore nobis praesentium dolore quae exercitationem, a fugit. Fugit tenetur aspernatur exercitationem aut? Optio tempora soluta ipsum neque natus, sed sunt officia obcaecati. Ipsa eum voluptates ducimus ratione enim voluptate assumenda laudantium nulla magni, cum rem maiores necessitatibus deleniti.
								</div>
							</div>
						</li>
						
						<li class="space-y-8">
							<h4 class="text-dark text-justify">Lorem ipsum dolor, sit amet consectetur adipisicing elit. Cum quae repudiandae ipsam, totam debitis impedit nisi ut maxime officia ullam provident! Laborum nobis non reprehenderit excepturi, ducimus quod nesciunt nisi fugiat ut.</h4>
							
							<div class="block my-4 space-y-4">
								<span class="p-4 text-dark text-center float-right">
									<input type="text" x-on:click.stop class="w-10 border-0 border-b-2 border-secondary text-center p-1 focus:ring-0 focus:border-primary">
									<h5 class="inline"> / 25</h5>
								</span>
								
								<div class="p-4 w-full max-h-64 overflow-y-auto scrollbar text-secondary shadow-lg rounded-lg border border-slate-100">
									Lorem ipsum dolor sit amet consectetur adipisicing elit. Autem esse natus, sunt fuga enim facere impedit vero odio molestiae accusantium voluptas alias excepturi earum deleniti, quos, nemo quae et consequuntur quo assumenda? Debitis ut vitae eaque tempora. Explicabo ut commodi temporibus fugiat similique quasi dicta. Harum dolor iure reprehenderit. Quos illum, facilis qui fuga eos sed similique et atque eaque officiis tempore nobis praesentium dolore quae exercitationem, a fugit. Fugit tenetur aspernatur exercitationem aut? Optio tempora soluta ipsum neque natus, sed sunt officia obcaecati. Ipsa eum voluptates ducimus ratione enim voluptate assumenda laudantium nulla magni, cum rem maiores necessitatibus deleniti.
								</div>
							</div>
						</li>
					</ol>
				</div>
				{{-- Main Page End --}}
				
				{{-- Footer Page Start --}}
				<div class="flex items-end justify-between mt-8">
					<button type="button" class="flex flex-nowrap items-center justify-center my-2 p-1 bg-primary rounded-full transition duration-300 hover:ring hover:ring-primary-200/70 hover:shadow-md">
						<span class="material-symbols-outlined text-white">
							navigate_before
						</span>
						
						<span class="text-white mr-2">Prev</span>
					</button>
					
					<button type="button" class="flex flex-nowrap items-center justify-center my-2 p-1 bg-primary rounded-full transition duration-300 hover:ring hover:ring-primary-200/70 hover:shadow-md">
						<span class="text-white ml-2">Next</span>
						
						<span class="material-symbols-outlined text-white">
							navigate_next
						</span>
					</button>
				</div>
				{{-- Footer Page End --}}
			</div>
		</div>
	</div>
@endsection